<?php
load_lng('u9/');

// Main class of module U9
class U9 {
  function U9($cfg_name = '')
  {
    global $mobj;

    // Default
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u9_configuration where id='sbs_wp_u9_default'";
    $R = $mobj->DB_db_query();
    $tmp = $mobj->DB_fetch_assoc($R);
    foreach ($tmp as $field=>$val) {
      if (trim($val) == '') eval('$this->'.$field.' = "";');
      if ($field == 'tmpl_statistics_hosts_row') $this->tmpl_statistics_hosts_row = $val;
      elseif ($field == 'tmpl_statistics_url_row') $this->tmpl_statistics_url_row = $val;
      elseif ($field == 'tmpl_statistics_hits_row') $this->tmpl_statistics_hits_row = $val;
      elseif ($field == 'tmpl_entry_points_row') $this->tmpl_entry_points_row = $val;
      elseif ($field == 'tmpl_traffic_row') $this->tmpl_traffic_row = $val;
      elseif ($field == 'tmpl_search_words_row') $this->tmpl_search_words_row = $val;
      elseif ($field == 'tmpl_referers_row') $this->tmpl_referers_row = $val;
      elseif (!empty($val) and !in_array($field, array('id','uid','gid_r','gid_w','gid_i','parent_id','_date','host','title'))) eval('$this->'.$field.' = '.$val.';');
    }
    // Special if specified
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u9_configuration where id='$cfg_name'";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) > 0) {
      $tmp = $mobj->DB_fetch_assoc($R);
      foreach ($tmp as $field=>$val) {
        if ($val != '-1') {
          if (trim($val) == '') eval('$this->'.$field.' = "";');
          if ($field == 'tmpl_statistics_hosts_row') $this->tmpl_statistics_hosts_row = $val;
          elseif ($field == 'tmpl_statistics_url_row') $this->tmpl_statistics_url_row = $val;
          elseif ($field == 'tmpl_statistics_hits_row') $this->tmpl_statistics_hits_row = $val;
          elseif ($field == 'tmpl_entry_points_row') $this->tmpl_entry_points_row = $val;
          elseif ($field == 'tmpl_traffic_row') $this->tmpl_traffic_row = $val;
          elseif ($field == 'tmpl_search_words_row') $this->tmpl_search_words_row = $val;
          elseif ($field == 'tmpl_referers_row') $this->tmpl_referers_row = $val;
          elseif (!empty($val) and !in_array($field, array('id','uid','gid_r','gid_w','gid_i','parent_id','_date','host','title'))) eval('$this->'.$field.' = '.$val.';');
        }
      }
    }
  }

  // Return statistics
  // $statistics_type: 1 - IP addresses, 2 - hits, 3 - popularity of pages
  function u9get_statistics($statistics_type, $date_b = '', $date_e = '')
  {
    global $mobj;

    if (!$date_b) $date_b = date('Y-m-d');
    if (!$date_e) $date_e = date('Y-m-d');
    $date_e .= ' 23:59:59';
    $this->HTML_statistics = '';
    $suf = " where _date>='$date_b' and _date<='$date_e'";

    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits$suf";
    $total_hits = $mobj->DB_result($mobj->DB_db_query(), 0);

    switch ($statistics_type) {
      case '1':
        $suf_type .= " group by host";
        $template = $this->tmpl_statistics_hosts_row;
        break;
      case '2':
        $suf_type .= " order by _date";
        $template = $this->tmpl_statistics_hits_row;
        break;
      case '3':
        $suf_type .= " group by url";
        $template = $this->tmpl_statistics_url_row;
        break;
    }

    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u9_hits$suf$suf_type";
    $R = $mobj->DB_db_query();
    $this->lq_rec_q = $mobj->DB_num_rows($R);
    if ($R = $mobj->DB_db_query())
      for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
        $statistics_row = $mobj->DB_fetch_object($R);
        if ($statistics_type == '1') {
          $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits$suf and host='".$statistics_row->host."'";
          $R1 = $mobj->DB_db_query();
          $statistics_row->q = $mobj->DB_result($R1,0). ' ('.sprintf('%01.2f', $mobj->DB_result($R1,0)*100/$total_hits).'%)';
        }
        if ($statistics_type == '3') {
          $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits$suf and url='".$statistics_row->url."'";
          $R1 = $mobj->DB_db_query();
          $statistics_row->q = $mobj->DB_result($R1,0). ' ('.sprintf('%01.2f', $mobj->DB_result($R1,0)*100/$total_hits).'%)';
        }
        eval($template);
        $this->HTML_statistics .= $this->statistics_row;
        if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_statistics .= $this->statistics_div;
      }
    $this->total_hits = $total_hits;
  }

  // Return summary statistics
  function u9get_summary()
  {
    global $mobj;

    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits";
    $summary->hits_total = $mobj->DB_result($mobj->DB_db_query(), 0);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d 00:00:00')."' and _date<='".date('Y-m-d 23:59:59')."'";
    $summary->hits_today = $mobj->DB_result($mobj->DB_db_query(), 0);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-1 days'))." 23:59:59'";
    $summary->hits_yesterday = $mobj->DB_result($mobj->DB_db_query(), 0);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 weeks'))." 00:00:00' and _date<='".date('Y-m-d')." 23:59:59'";
    $summary->hits_7 = $mobj->DB_result($mobj->DB_db_query(), 0);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 month'))." 00:00:00' and _date<='".date('Y-m-d')." 23:59:59'";
    $summary->hits_30 = $mobj->DB_result($mobj->DB_db_query(), 0);

    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits group by host";
    $summary->hosts_total = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d 00:00:00')."' and _date<='".date('Y-m-d 23:59:59')."' group by host";
    $summary->hosts_today = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-1 days'))." 23:59:59' group by host";
    $summary->hosts_yesterday = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 weeks'))." 00:00:00' and _date<='".date('Y-m-d')." 23:59:59' group by host";
    $summary->hosts_7 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 month'))." 00:00:00' and _date<='".date('Y-m-d')." 23:59:59' group by host";
    $summary->hosts_30 = $mobj->DB_num_rows($mobj->DB_db_query());

    return $summary;
  }

  // Return "search words"-statistics
  function u9get_search_words($date_b, $date_e)
  {
    global $mobj;

    if (!$date_b) $date_b = date('Y-m-d');
    if (!$date_e) $date_e = date('Y-m-d');
    $date_e .= ' 23:59:59';
    $this->HTML_records = '';
    $suf = " where _date>='$date_b' and _date<='$date_e'";

    $mobj->SQL = "select url_referer from "._MOBJ_DB_TPREF_."u9_hits$suf
      and url_referer like '%yandex.ru/yandsearch?text=%'
      ";
    $R = $mobj->DB_db_query();
    for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
      preg_match_all ("/yandex.ru\/yandsearch\?text=(.*)/", $mobj->DB_result($R, $I), $tmp);
      $word = urldecode($tmp[1][0]);

      $statistics_row->url_referer = $mobj->DB_result($R, $I);
      $statistics_row->word = $word;

      eval($this->tmpl_search_words_row);
      $this->HTML_records .= $this->statistics_row;
      if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_records .= $this->statistics_div;
    }
  }

  // Return "traffic"-statistics
  // Out: 1 if period is wrong
  function u9get_traffic($date_b, $date_e)
  {
    global $mobj;

    $this->HTML_records = '';

    $tmp_b = explode('-', substr($date_b, 0, 10));
    $tmp_e = explode('-', substr($date_e, 0, 10));
    $date_b_stamp = mktime($I,0,0,$tmp_b[1],$tmp_b[2],$tmp_b[0]);
    $date_e_stamp = mktime($I,0,0,$tmp_e[1],$tmp_e[2],$tmp_e[0]);

    if ($date_b_stamp > $date_e_stamp) return 1;

    for ($I=0;$date_stamp<$date_e_stamp;$I=$I+24) {
      $date_stamp = mktime($I,0,0,$tmp_b[1],$tmp_b[2],$tmp_b[0]);
      $suf = " where _date>='".date('Y-m-d', $date_stamp)." 00:00:00' and _date<='".date('Y-m-d', $date_stamp)." 23:59:59'";
      $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits$suf";
      $Rhits = $mobj->DB_db_query();
      $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits$suf group by host";
      $Rhosts = $mobj->DB_db_query();

      $statistics_row->date = date('Y-m-d', $date_stamp);
      $statistics_row->hits = $mobj->DB_result($Rhits, 0);
      $statistics_row->hosts = $mobj->DB_num_rows($Rhosts, 0);

      eval($this->tmpl_traffic_row);
      $this->HTML_records .= $this->statistics_row;
      if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_records .= $this->statistics_div;
    }
  }

  // Return "referer pages"-statistics
  function u9get_referers($date_b, $date_e)
  {
    global $mobj;

    $this->HTML_records = '';

    if (!$date_b) $date_b = date('Y-m-d');
    if (!$date_e) $date_e = date('Y-m-d');
    $date_e .= ' 23:59:59';
    $this->HTML_records = '';
    $suf = " where _date>='$date_b' and _date<='$date_e'";

    $mobj->SQL = "select url_referer from "._MOBJ_DB_TPREF_."u9_hits$suf and url_referer<>'' group by url_referer";
    $R = $mobj->DB_db_query();
    for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
      $statistics_row->url_referer = $mobj->DB_result($R, $I);

      eval($this->tmpl_referers_row);
      $this->HTML_records .= $this->statistics_row;
      if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_records .= $this->statistics_div;
    }
  }

  // Return list of entry points
  function u9get_entry_points($date_b = '', $date_e = '')
  {
    global $mobj;

    if (!$date_b) $date_b = date('Y-m-d');
    if (!$date_e) $date_e = date('Y-m-d');
    $date_e .= ' 23:59:59';
    $this->HTML_statistics = '';
    $suf = " where _date>='$date_b' and _date<='$date_e'";

    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u9_hits$suf order by _date";
    $R = $mobj->DB_db_query();
    $this->lq_rec_q = $mobj->DB_num_rows($R);
    if ($R = $mobj->DB_db_query())
      for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
        $statistics_row = $mobj->DB_fetch_object($R);
        if ($statistics_type == '3') {
          $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits$suf and url='".$statistics_row->url."'";
          $R1 = $mobj->DB_db_query();
          $statistics_row->q = $mobj->DB_result($R1,0);
        }
        eval($this->tmpl_entry_points_row);
        $this->HTML_statistics .= $this->statistics_row;
        if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_statistics .= $this->statistics_div;
      }
  }

  // Clears a statistics
  function u9clear_statistics($_date)
  {
    global $mobj;

    if (empty($_date)) return 1;

    $mobj->SQL = "delete from "._MOBJ_DB_TPREF_."u9_hits where _date < '".$_date."'";
    $mobj->DB_db_query();

    return 0;
  }
}

// Autonomous function for gathering of hit
function u9register_hit()
{
  global $mobj;

  $mobj->SQL = "insert into "._MOBJ_DB_TPREF_."u9_hits (_date, host, url, url_referer, user_agent) values('".date('Y-m-d H:i:s')."', '".Get_IP()."', 'http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]."', '".$_SERVER["HTTP_REFERER"]."', '".$_SERVER["HTTP_USER_AGENT"]."')";
  $mobj->DB_db_query();
}
?>